>From 6d6a56b3a079b8e6f56d098d169e52a46da68509 Mon Sep 17 00:00:00 2001
From: Christina Fu <cfu@redhat.com>
Date: Tue, 2 Dec 2014 14:38:08 -0800
Subject: [PATCH] Ticket #864 865 866 (part 1 symkey, common) NIST SP800-108
 KDF

---
 .../cms/selftests/tks/TKSKnownSessionKey.java      |  59 +-
 .../cms/servlet/csadmin/ConfigurationUtils.java    |   3 +
 .../com/netscape/cms/servlet/tks/TokenServlet.java | 665 +++++++++++++++++----
 base/server/cmsbundle/src/LogMessages.properties   |  80 +++
 base/symkey/src/com/netscape/symkey/CMakeLists.txt |   2 +
 .../symkey/src/com/netscape/symkey/EncryptData.cpp | 140 ++++-
 .../src/com/netscape/symkey/NistSP800_108KDF.cpp   | 470 +++++++++++++++
 .../src/com/netscape/symkey/NistSP800_108KDF.h     | 115 ++++
 base/symkey/src/com/netscape/symkey/SessionKey.cpp | 580 ++++++++++++++++--
 .../symkey/src/com/netscape/symkey/SessionKey.java |  25 +-
 base/symkey/src/com/netscape/symkey/SymKey.cpp     | 424 +++++++++++--
 base/tks/shared/conf/CS.cfg.in                     |  10 +-
 12 files changed, 2345 insertions(+), 228 deletions(-)
 create mode 100644 base/symkey/src/com/netscape/symkey/NistSP800_108KDF.cpp
 create mode 100644 base/symkey/src/com/netscape/symkey/NistSP800_108KDF.h

diff --git a/base/server/cms/src/com/netscape/cms/selftests/tks/TKSKnownSessionKey.java b/base/server/cms/src/com/netscape/cms/selftests/tks/TKSKnownSessionKey.java
index 06a6398..d8a2619 100644
--- a/base/server/cms/src/com/netscape/cms/selftests/tks/TKSKnownSessionKey.java
+++ b/base/server/cms/src/com/netscape/cms/selftests/tks/TKSKnownSessionKey.java
@@ -67,6 +67,9 @@ public class TKSKnownSessionKey
     private byte[] mCUID = null;
     private byte[] mMacKey = null;
     private byte[] mSessionKey = null;
+    private byte mNistSP800_108KdfOnKeyVersion = 0;       // AC: KDF SPEC CHANGE
+    private boolean mNistSP800_108KdfUseCuidAsKdd = false;  // AC: KDF SPEC CHANGE
+    private byte[] mKDD = null;                   // AC: KDF SPEC CHANGE
 
     /**
      * Initializes this subsystem with the configuration store
@@ -101,6 +104,46 @@ public class TKSKnownSessionKey
         mMacKey = getConfigByteArray("macKey", 16);
         mUseSoftToken = getConfigString("useSoftToken");
 
+        // AC: KDF SPEC CHANGE 
+        // read CUID for the KDD field
+        mKDD = getConfigByteArray("CUID", 10);
+        //
+        //
+        // read self-test configuration item for nistSP800-108KdfOnKeyVersion
+        //
+        // read setting as string
+        String nistSP800_108KdfOnKeyVersion_str = getConfigString("nistSP800-108KdfOnKeyVersion");
+        short nistSP800_108KdfOnKeyVersion_short;
+        // convert setting value (in ASCII-hex) to short
+        try{
+                nistSP800_108KdfOnKeyVersion_short = Short.parseShort(nistSP800_108KdfOnKeyVersion_str,16);
+                if ((nistSP800_108KdfOnKeyVersion_short < 0) || (nistSP800_108KdfOnKeyVersion_short > (short)0x00FF)){
+                        throw new Exception("Out of range.");
+                }
+        }catch(Throwable t){
+                mSelfTestSubsystem.log (mSelfTestSubsystem.getSelfTestLogger(),
+                    CMS.getLogMessage("SELFTESTS_MISSING_VALUES",
+                    getSelfTestName(), mPrefix + ".nistSP800-108KdfOnKeyVersion"));
+                throw new EMissingSelfTestException("nistSP800-108KdfOnKeyVersion");
+        }
+        // convert to byte (anything higher than 0x7F is represented as negative)
+        mNistSP800_108KdfOnKeyVersion = (byte)nistSP800_108KdfOnKeyVersion_short;
+        //
+        //
+        // read self-test configuration item for nistSP800-108KdfUseCuidAsKdd
+        //
+        // read setting as string
+        String nistSP800_108KdfUseCuidAsKdd_str = getConfigString("nistSP800-108KdfUseCuidAsKdd");
+        // convert setting value to boolean
+        try{
+                mNistSP800_108KdfUseCuidAsKdd = Boolean.parseBoolean(nistSP800_108KdfUseCuidAsKdd_str);
+        }catch(Throwable t){
+                mSelfTestSubsystem.log (mSelfTestSubsystem.getSelfTestLogger(),
+                    CMS.getLogMessage("SELFTESTS_MISSING_VALUES",
+                    getSelfTestName(), mPrefix + ".nistSP800-108KdfUseCuidAsKdd"));
+                throw new EMissingSelfTestException("nistSP800-108KdfUseCuidAsKdd");
+        }
+        
         String defKeySetMacKey = null;
         tks = CMS.getSubsystem(mTksSubId);
         if (tks != null) {
@@ -132,7 +175,12 @@ public class TKSKnownSessionKey
             if (mSessionKey == null) {
                 mSessionKey = SessionKey.ComputeSessionKey(mToken, mKeyName,
                                                             mCardChallenge, mHostChallenge,
-                                                            mKeyInfo, mCUID, mMacKey, mUseSoftToken, null, null);
+                                                            mKeyInfo, 
+                                                            mNistSP800_108KdfOnKeyVersion,   // AC: KDF SPEC CHANGE - pass in configuration self-test value
+                                                            mNistSP800_108KdfUseCuidAsKdd,   // AC: KDF SPEC CHANGE - pass in configuration self-test value
+                                                            mCUID,
+                                                            mKDD,                            // AC: KDF SPEC CHANGE - pass in KDD
+                                                            mMacKey, mUseSoftToken, null, null);
                 if (mSessionKey == null || mSessionKey.length != 16) {
                     mSelfTestSubsystem.log(mSelfTestSubsystem.getSelfTestLogger(),
                                             CMS.getLogMessage("SELFTESTS_MISSING_VALUES",
@@ -314,8 +362,13 @@ public class TKSKnownSessionKey
         String keySet = "defKeySet";
 
         byte[] sessionKey = SessionKey.ComputeSessionKey(
-                mToken, mKeyName, mCardChallenge, mHostChallenge, mKeyInfo,
-                mCUID, mMacKey, mUseSoftToken, keySet, sharedSecretName);
+                mToken, mKeyName, mCardChallenge, mHostChallenge,
+                mKeyInfo,
+                mNistSP800_108KdfOnKeyVersion,   // AC: KDF SPEC CHANGE - pass in configuration self-test value
+                mNistSP800_108KdfUseCuidAsKdd,   // AC: KDF SPEC CHANGE - pass in configuration self-test value
+                mCUID,
+                mKDD,                            // AC: KDF SPEC CHANGE - pass in KDD
+                mMacKey, mUseSoftToken, keySet, null);
 
         // Now we just see if we can successfully generate a session key.
         // For FIPS compliance, the routine now returns a wrapped key, which can't be extracted and compared.
diff --git a/base/server/cms/src/com/netscape/cms/servlet/csadmin/ConfigurationUtils.java b/base/server/cms/src/com/netscape/cms/servlet/csadmin/ConfigurationUtils.java
index f443238..a7eec4e 100644
--- a/base/server/cms/src/com/netscape/cms/servlet/csadmin/ConfigurationUtils.java
+++ b/base/server/cms/src/com/netscape/cms/servlet/csadmin/ConfigurationUtils.java
@@ -273,6 +273,8 @@ public class ConfigurationUtils {
             HttpResponse httpresponse = httpclient.send(httprequest);
 
             c = httpresponse.getContent();
+            //cfu
+            
         } catch (ConnectException e) {
             CMS.debug("getHttpResponse: " + e.toString());
             throw new IOException("The server you tried to contact is not running.");
@@ -4023,6 +4025,7 @@ public class ConfigurationUtils {
             CMS.debug("registerUser: response is empty or null.");
             throw new IOException("The server " + targetURI + "is not available");
         } else {
+            CMS.debug("registerUser: response: " + response);
             ByteArrayInputStream bis = new ByteArrayInputStream(response.getBytes());
             XMLObject parser = new XMLObject(bis);
 
